# coding: utf-8

"""
    Marketing Emails

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from hubspot.marketing.emails.api_client import ApiClient
from hubspot.marketing.emails.exceptions import ApiTypeError, ApiValueError  # noqa: F401


class StatisticsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_emails_list(self, **kwargs):  # noqa: E501
        """Get aggregated statistics.  # noqa: E501

        Use this endpoint to get aggregated statistics of emails sent in a specified time span. It also returns the list of emails that were sent during the time span.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_emails_list(async_req=True)
        >>> result = thread.get()

        :param start_timestamp: The start timestamp of the time span, in ISO8601 representation.
        :type start_timestamp: str
        :param end_timestamp: The end timestamp of the time span, in ISO8601 representation.
        :type end_timestamp: str
        :param email_ids: Filter by email IDs. Only include statistics of emails with these IDs.
        :type email_ids: list[int]
        :param _property: Specifies which email properties should be returned. All properties will be returned by default.
        :type _property: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: AggregateEmailStatistics
        """
        kwargs["_return_http_data_only"] = True
        return self.get_emails_list_with_http_info(**kwargs)  # noqa: E501

    def get_emails_list_with_http_info(self, **kwargs):  # noqa: E501
        """Get aggregated statistics.  # noqa: E501

        Use this endpoint to get aggregated statistics of emails sent in a specified time span. It also returns the list of emails that were sent during the time span.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_emails_list_with_http_info(async_req=True)
        >>> result = thread.get()

        :param start_timestamp: The start timestamp of the time span, in ISO8601 representation.
        :type start_timestamp: str
        :param end_timestamp: The end timestamp of the time span, in ISO8601 representation.
        :type end_timestamp: str
        :param email_ids: Filter by email IDs. Only include statistics of emails with these IDs.
        :type email_ids: list[int]
        :param _property: Specifies which email properties should be returned. All properties will be returned by default.
        :type _property: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(AggregateEmailStatistics, status_code(int), headers(HTTPHeaderDict))
        """

        local_var_params = locals()

        all_params = ["start_timestamp", "end_timestamp", "email_ids", "_property"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method get_emails_list" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]

        collection_formats = {}

        path_params = {}

        query_params = []
        if local_var_params.get("start_timestamp") is not None:  # noqa: E501
            query_params.append(("startTimestamp", local_var_params["start_timestamp"]))  # noqa: E501
        if local_var_params.get("end_timestamp") is not None:  # noqa: E501
            query_params.append(("endTimestamp", local_var_params["end_timestamp"]))  # noqa: E501
        if local_var_params.get("email_ids") is not None:  # noqa: E501
            query_params.append(("emailIds", local_var_params["email_ids"]))  # noqa: E501
            collection_formats["emailIds"] = "multi"  # noqa: E501
        if local_var_params.get("_property") is not None:  # noqa: E501
            query_params.append(("property", local_var_params["_property"]))  # noqa: E501

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["application/json", "*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {
            200: "AggregateEmailStatistics",
        }

        return self.api_client.call_api(
            "/marketing/v3/emails/statistics/list",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )

    def get_histogram(self, **kwargs):  # noqa: E501
        """Get aggregated statistic intervals.  # noqa: E501

        Get aggregated statistics in intervals for a specified time span. Each interval contains aggregated statistics of the emails that were sent in that time.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_histogram(async_req=True)
        >>> result = thread.get()

        :param interval: The interval to aggregate statistics for.
        :type interval: str
        :param start_timestamp: The start timestamp of the time span, in ISO8601 representation.
        :type start_timestamp: str
        :param end_timestamp: The end timestamp of the time span, in ISO8601 representation.
        :type end_timestamp: str
        :param email_ids: Filter by email IDs. Only include statistics of emails with these IDs.
        :type email_ids: list[int]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CollectionResponseWithTotalEmailStatisticIntervalNoPaging
        """
        kwargs["_return_http_data_only"] = True
        return self.get_histogram_with_http_info(**kwargs)  # noqa: E501

    def get_histogram_with_http_info(self, **kwargs):  # noqa: E501
        """Get aggregated statistic intervals.  # noqa: E501

        Get aggregated statistics in intervals for a specified time span. Each interval contains aggregated statistics of the emails that were sent in that time.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_histogram_with_http_info(async_req=True)
        >>> result = thread.get()

        :param interval: The interval to aggregate statistics for.
        :type interval: str
        :param start_timestamp: The start timestamp of the time span, in ISO8601 representation.
        :type start_timestamp: str
        :param end_timestamp: The end timestamp of the time span, in ISO8601 representation.
        :type end_timestamp: str
        :param email_ids: Filter by email IDs. Only include statistics of emails with these IDs.
        :type email_ids: list[int]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CollectionResponseWithTotalEmailStatisticIntervalNoPaging, status_code(int), headers(HTTPHeaderDict))
        """

        local_var_params = locals()

        all_params = ["interval", "start_timestamp", "end_timestamp", "email_ids"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method get_histogram" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]

        collection_formats = {}

        path_params = {}

        query_params = []
        if local_var_params.get("interval") is not None:  # noqa: E501
            query_params.append(("interval", local_var_params["interval"]))  # noqa: E501
        if local_var_params.get("start_timestamp") is not None:  # noqa: E501
            query_params.append(("startTimestamp", local_var_params["start_timestamp"]))  # noqa: E501
        if local_var_params.get("end_timestamp") is not None:  # noqa: E501
            query_params.append(("endTimestamp", local_var_params["end_timestamp"]))  # noqa: E501
        if local_var_params.get("email_ids") is not None:  # noqa: E501
            query_params.append(("emailIds", local_var_params["email_ids"]))  # noqa: E501
            collection_formats["emailIds"] = "multi"  # noqa: E501

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["application/json", "*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {
            200: "CollectionResponseWithTotalEmailStatisticIntervalNoPaging",
        }

        return self.api_client.call_api(
            "/marketing/v3/emails/statistics/histogram",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )
